﻿// circle_text.jsx
// this script places all incom projects onto a large page
//

// not based on but this helped on the first steps 
// InsertMultipleImages.js by Brian Reyman
// http://www.adobe.com/cfusion/exchange/index.cfm?event=extensionDetail&extid=1046817

// and theImageGrid.jsx by fabiantheblind
// https://raw.github.com/fabiantheblind/theGrids/master/imageGrid/theImageGrid.jsx

// Copyright (C) 2011 Fabian "fabiantheblind" Morón Zirfas
// http://www.the-moron.net
// http://fabiantheblind.info/
// info [at] the - moron . net

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/


//~ our project for this script is stunning white noise id 1173
//~ id: 189 title: DUKOMENTATION IAIV Fabian Mor&Ucirc;n Zirfas
//~ id: 700 title: [Corporate Motion] SPECTRE
//~ id: 1173 title: Stunning White Noise
//~ id: 1179 title: DisasterManagement
//~ id: 1297 title: UEA2
//~ id: 1488 title: Incom(API) 2 &hellip;
//~ id: 1791 title: Praktikumsemester Forseesense
//~ id: 1792 title: Kopf Hand Fuss F. Mor&oacute;n Zirfas
//~ id: 1793 title: noise mashine
//~ id: 1751 title: Garfikdesign &quot;T.I.L.Y. &amp;&amp; Anti.Soc.Icon.&quot;
//~ id: 1752 title: Advertising Design Help
//~ id: 1753 title: CutUP.14 Corporate Deathmatch
//~ id: 1754 title: Produktdesign/Digitale Medien FFF
//~ id: 1755 title: Lug und Trug Recycling
//~ id: 1756 title: Kultur-, Kunst- und Designgeschichte Feng Mengbo
//~ id: 1757 title: Blue Ocean Gero
//~ id: 1758 title: Produktion von Printmedien FMZ
//~ id: 1759 title: Design Versprechen Konfetti
//~ id: 1798 title: InDesign Scripting Tutorial
//~ id: 1799 title: Americas Army Serious Games
//~ id: 1800 title: Grundkurs C / C++
//~ id: 1362 title: UE_Laerm
#include "db.json"
#include "utility.jsx"
#include "db_utils.jsx"
#include "colors.jsx"
#include "document.jsx"
#include "styles.jsx"
#include "weblinks.jsx"

var meta = new Object();
	meta.db = data;// this comes from the included db.json
	meta.prjList = [1173, 1362, 1754]; // the projects to highlite
	meta.highlite = [
	{"id":0, "name":"0","col":[255,255,255]}];
	
	meta.DEBUG = false; // this is for debugging
	
	// this is for quicker editing 
	// in the final render switch in the overlay and the image place
	meta.placeImages = true;   
	meta.addImageOverlay = true;
	meta.skipImages = false;
    meta.colorsonly = false;
	meta.pw = 2000; // this will hold the page width
	meta.ph = 2000; // this will hold the page width
	meta.flsFolder = null;// the folder for the images
	meta.imgW = 25; // the image sizes
	meta.imgH = 25;
   meta.coordInText = null;

//~	 meta.step = 1; // the step for selecting the images
	
	// these are the margins
	meta.left = 100;
	meta.right = 100;
	meta.top = 100;
	meta.bottom = 100;
	meta.textColumnCount = 1;
	// this will be filled with data from the db.json
	// sorted by startdate
	meta.sortedFiles = null; 
  
//~	 meta.Masterframe = null;
	db_sort_by_starttime();
	db_remove_firstelement();// removes old junk
	db_build_imageList();
	meta.cCount = 80;
    // calculate the gutter depending on how many images per column
    meta.gutter = ((meta.pw - (meta.left + meta.right)) - (meta.imgW*80)) / 79;

	main();
    
function main(){
    
    var d = app.documents.add(); //build a basic document
	colors_builder(d);
    if(meta.colorsonly)return;
	styles_builder(d); // build some paragrph styles
//~ return;	
    doc_build (d);// build the document
    
	util_getfilesFolder();// opens a prompt and lets the user choose a folder
    // now when you use place() write this
    // it will give you the file with the folder you need
    /*
    

				meta.flsFolder.fsName + "/" + util_checkFileType(meta.sortedFiles[iter].filename)    
    
    
    */
var p = d.pages.item(0);// finally - get the first page
	p.appliedMaster = d.masterSpreads.item(0);// apply the masterspread
   
//~ last bounds is for the textframe so he 
//~ will always be positioned depending on the mass of images
var lastBnds = null; 
lastBnds = [meta.top,meta.left,meta.top + 10, meta.pw - meta.right];

var tf =   p.textFrames.add({
    geometricBounds:[
    lastBnds[2]+ meta.gutter*5,
    meta.left ,
    meta.ph- meta.bottom, meta.pw - meta.right]
    });// make the new textfrmae
    tf.label = "masterframe";
	tf.itemLayer = d.layers.item("content");
	tf.textFramePreferences.textColumnGutter = 5;
	tf.textFramePreferences.textColumnCount  = meta.textColumnCount;
//~	 meta.masterFrame = tf;
	text_place(tf);
//~ 	tf.paragraphs.everyItem().appliedParagraphStyle = "body";
	text_takeOutTheTrash(d); // This removes html formatting
	text_grepReformatting(d); // this removes some things and adds new paragraphs for the important projects
//~ 	text_addLegend(tf);
    text_FormatParagraphs(d,tf);
    text_fix_last_line (tf);
    
    addCircle (d, p, [(meta.ph/2) - meta.imgH,(meta.pw/2) - meta.imgW,(meta.ph/2) + meta.imgH,(meta.pw/2) + meta.imgW], tf);

    
    
    find_hyperlinks();
    text_build_headline (d, p);
    find_hyperlinks();// we need to add another hyperlink


    meta.coordInText = text_find_ids(d);

    make_projects_circle_and_connect (d, p);
    
    
    }

function text_find_ids(doc){
   var fTPref  = app.findTextPreferences;
    var cTPref = app.changeTextPreferences;
	var result = new Array();
	text_emptyFC();
        var list = null;
    if(meta.highliteOnly ){
        list = meta.highlite;
        }else{
        list = meta.db.projects;
        }
    
    
	// now loop thru the object to get all the greps
	for(var j = 0;j < list.length;j++){
        fTPref.findWhat = "i";
        fTPref.appliedCharacterStyle = "id "+list[j].id;
//~         cTPref.leading = 16;
//~         if(util_checkhighlite (list[j].id)){
        var res = doc.findText();
//~         alert(res.length);
//~ x: app.selection[0].horizontalOffset
//~ y: app.selection[0].baseline        
//~         alert( "x: " +  res[0].horizontalOffset +" y: "+ res[0].baseline);
        result.push({"x":res[0].horizontalOffset,"y":res[0].baseline, "id":list[j].id});
//~         alert(result.toSource());
//~         }
//~         alert(res);
        text_emptyFC();
	}
	text_emptyFC();    
    
    
    return result;
    }

function get_coordByID(id){
    for(var i = 0; i < meta.coordInText.length; i++){
        if(id == meta.coordInText[i].id){
        return [meta.coordInText[i].x,meta.coordInText[i].y];
        }
    }
}

function make_projects_circle_and_connect(d,p){

    var x1 = meta.left;
    var y1 = meta.top;
    var ovs = new Array();
    for(var i in meta.db.projects){
    var x2 = x1 + meta.imgW;
    var y2 = y1 + meta.imgH;
    
    var oval = p.ovals.add({geometricBounds:[y1,x1,y2,x2]});
        oval.place(meta.flsFolder.fsName + "/" +     meta.db.projects[i].id + ".jpg");
    make_button_with_url(oval, "http://incom.org/projekt/"+meta.db.projects[i].id,meta.db.projects[i].id)
    image_tint_and_fit (meta.db.projects[i].id, oval);// giv it the right color and fit the image to the circle
        oval.label = ""+ meta.db.projects[i].id;
        ovs.push(oval);
        
        
       var tf = p.textFrames.add({geometricBounds:[
            y1 - meta.imgH/3,
            x1 + meta.imgW /2,
            y1 + 50,
            x1+150]});

        tf.contents = meta.db.projects[i].title;
        tf.paragraphs.everyItem().applyCharacterStyle(d.characterStyles.item("h1 "+ meta.db.projects[i].id));
        tf.fit(FitOptions.FRAME_TO_CONTENT);

   var rotTM = app.transformationMatrices.add({counterclockwiseRotationAngle:45 });// rotate (the 180 is for getting the line start upwards)
		tf.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.LEFT_CENTER_ANCHOR, rotTM);


        x1 = x1 + meta.imgW + meta.gutter;
//~     y1 = y2 + meta.gutter;
    
        }
    

    for(var j in ovs){
        
        var o = ovs[j];
        var coords = get_coordByID( parseInt (o.label));
         var w = o.geometricBounds[3] - o.geometricBounds[1];
          var h = o.geometricBounds[2] - o.geometricBounds[0];
          var x1 = o.geometricBounds[1] + (w/2);
           var y1 = o.geometricBounds[0] + (h/2);
           var x2 = coords[0] - 2;
           var y2 = coords[1] - 2;
           var gl = draw_line (p, x1, y1, x2, y2);
           gl.strokeWeight = 1;
           gl.strokeColor = o.label;
           gl.sendToBack();

        }    
    
    
    
    }

// tint and fit the image
function image_tint_and_fit(id,oval){
                oval.images.item(0).fillColor = id + "";
                oval.fit(FitOptions.FILL_PROPORTIONALLY);// center it
                oval.fit(FitOptions.CENTER_CONTENT);// center it


} // END TINT

// this draws the lines with 4 pathpoints
function draw_line(p,x1,y1,x2,y2){
   
	var gl = p.graphicLines.add(); 
    
    var p1 = gl.paths[0].pathPoints[0];
    var p2 = gl.paths[0].pathPoints[1];
//~     var p3 = gl.paths[0].pathPoints.add();
    
    p1.anchor  = [x1,y1];
//~     p1.rightDirection = [x1 -30, y1- 30];
//~     p2.anchor = [x1 + 150,y2];
//~     p2.rightDirection = [x1 + 150 ,y2 + 150];
//~         p2.leftDirection = [x1 - 150 ,y2 - 150];

    p2.anchor  = [x2,y2];
    
    return gl;
    }
// put add circle into add circle
// warning this gut give an infinte loop if overflow never gets false
function addCircle(doc,page,bounds, tf){
    
    var ov = page.ovals.add({geometricBounds:bounds});
    ov.strokeWeight = 0;
   var rotTM = app.transformationMatrices.add({counterclockwiseRotationAngle:180 });// rotate (the 180 is for getting the line start upwards)
		ov.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.CENTER_ANCHOR, rotTM);
    var tp = ov.textPaths.add();
     tp.previousTextFrame = tf;
      if(tf.label.match("masterframe")){
          tf.remove();
          }
     if(tp.overflows){
         var bnds = [ov.geometricBounds[0]-5,ov.geometricBounds[1]-5,ov.geometricBounds[2]+5,ov.geometricBounds[3]+5];
         addCircle(doc,page,bnds, ov.textPaths[0]);
         }
    }


function text_FormatParagraphs(doc,tf){
    var fTPref  = app.findTextPreferences;
var cTPref = app.changeTextPreferences;
	
	text_emptyFC();
	// now loop thru the object to get all the greps
	for(var j = 0;j < meta.db.projects.length;j++){

        fTPref.appliedCharacterStyle = "h1 "+meta.db.projects[j].id;
        cTPref.leading = 16;
        if(util_checkhighlite (meta.db.projects[j].id)){
        var res = doc.changeText();
        }
//~         alert(res);
        text_emptyFC();
	}
	text_emptyFC();
    
   	// now loop thru the object to get all the greps
	for(var i = 0;i < meta.db.projects.length;i++){

        fTPref.appliedCharacterStyle = "h2 "+meta.db.projects[i].id;
        cTPref.leading = 16;
                if(util_checkhighlite (meta.db.projects[i].id)){
        var res = doc.changeText();
        }
//~         alert(res);
        text_emptyFC();
	} 



   	// now loop thru the object to get all the greps
	for(var i = 0;i < meta.db.projects.length;i++){

        fTPref.appliedCharacterStyle = "id "+meta.db.projects[i].id;
        cTPref.leading = 12;
                if(!util_checkhighlite (meta.db.projects[i].id)){
        var res = doc.changeText();
        }
//~         alert(res);
        text_emptyFC();
	} 
    
    
}


function text_fix_last_line(tf){
        for (var i  = 0; i < tf.paragraphs.length;i++){

            if(tf.paragraphs.item(i).fillTint  == 100 && tf.paragraphs.item(i).characters.item(0).appliedCharacterStyle.name.match("body")){
//~                     alert("found a fill");
            tf.paragraphs.item(i).leading = 12;
                    }
            
            }
    
}


function text_build_headline(doc,page){
    var x1 = meta.left;
    var y1 = meta.ph - meta.bottom + meta.gutter;
    var x2 = meta.pw - meta.right;
    var y2 = meta.ph;
     var tf = page.textFrames.add({geometricBounds:[y1,x1,y2,x2]});
     var dt = new Date();
    tf.contents = "6479: Fabian Morón Zirfas\n"+
    "build on: " + dt.getFullYear() + "/"+dt.getMonth() + 1 + "/"+dt.getDate() +
    "\nIn "+db_get_timespan ()+" days I made " + db_build_stats (doc) +". "+ text_count_words(doc)  +
    " get the code over there http://fabiantheblind.github.com/incomOrg2Layout/";
    tf.paragraphs.everyItem().appliedParagraphStyle = doc.paragraphStyles.item("head");
    
    }




function text_count_words(doc){
    var str = "";
	var ad = doc;
	var tf = ad.textFrames;
	var tflg = tf.length;

		var wcount = 0;
		var chcount = 0;
		var pcount=0;

		for(var i=0; i<tflg; i++)
		{	
			var p = tf[i].paragraphs;
			for(var l=0; l<p.length; l++)
			{
				pcount+=1;
				wcount += p[l].words.length;
				chcount += p[l].characters.length;
			}
		}
//		french
//		alert("Votre document comporte :"+"\r"
//        	+ "- "+tflg+ " bloc(s) texte(s)" + "\r"
//			+ "- "+pcount + " paragraphe(s)" + "\r"
//			+ "- " +wcount + " mot(s)" + "\r" 
//			+ "- "+chcount + " caractère(s) avec espaces" + "\r" 
//			+ "- "+(chcount-spaced()) + " caractère(s) sans espaces");
		str = "There is/are "+pcount + " paragraph(s)," + ""
			+ " with " +wcount + " word(s)," + "" 
			+ " with "+chcount + " character(s) (with whitespaces)" + "" 
			+ " or "+(chcount-text_spaced()) + " character(s) (without whitespaces)";
	


return str;
}
function text_spaced()
{
	app.findGrepPreferences = app.changeGrepPreferences = null;
	app.findGrepPreferences.findWhat="\s";
	return app.activeDocument.findGrep().length;
}



function text_insertWithNL(txt,type){

var lf = "<LF>";// we add this to the highlite projects to add a new line
	
	if(type.match("legend")){
		return  txt;
		}else{
	return lf + txt;
	};
}


function text_add_and_format(tf,content,car,i,j,type){
				
var tempTF = tf.parent.textFrames.add({geometricBounds:[
				meta.ph - 100, meta.left, meta.ph, meta.left+100]});

			  
	// from here on it is some kind of "manual" selection
	//what to edit and highlite in the text
			  
	if(util_checkhighlite (meta.db.projects[i].id) == true){
	//
	// this is project White Noise
	//
var res = "";

	if(meta.db.projects[i].posts[j].id == 17135 && type.match("post text")){
	var txt = content;
		res = text_tweakNoiseText(txt);
		tempTF.contents = text_insertWithNL(res,type);
		tempTF.paragraphs.everyItem().applyCharacterStyle(
		app.activeDocument.characterStyles.item("whitenoise 1173"));			
	}else{
				  
				  
		res = content;
		tempTF.contents =   text_insertWithNL(res,type);
		try{
			tempTF.paragraphs.everyItem().applyCharacterStyle(
			tempTF.parent.parent.characterStyles.item(car + " "+meta.db.projects[i].id)
			);
            
		}catch(e){alert(car + "\n" + e );}
                tempTF.paragraphs.everyItem().leading = 12;    

	}// close else

		tempTF.paragraphs.everyItem().fillTint = 100;
	}else{

		//
		// this is all the other projects
//~         if(type.match("post text") || type.match("text")){
//~ 		tempTF.contents = content;//text_insertWithNL(content,type);
//~         }else{
		tempTF.contents = content;//text_insertWithNL(content,type);
            
//~             }		
    
        tempTF.paragraphs.everyItem().applyCharacterStyle(
			app.activeDocument.characterStyles.item(car + " " + meta.db.projects[i].id));
        tempTF.paragraphs.everyItem().leading = 12;    
		if(type.match("legend")){
			tempTF.paragraphs.everyItem().fillTint = 100;	  
		}
	}
	tempTF.previousTextFrame = tf;
	tempTF.remove();
}

function text_tweakNoiseText(txt){

var noiseTXT = new Array();
var noiseVals = new Array();
	
	noiseTXT = txt.split(",");

	for(var n = 0; n < noiseTXT.length;n++){
		var t = parseFloat(noiseTXT[n]);
		noiseVals[n] = t.toFixed(10);
		}
	noiseVals.shift();
		
var str = "";
	for(s = 0; s < noiseVals.length;s++){
		if(noiseVals[s] >= 0 ){
			str = str + "+" + noiseVals[s] + " \t ";
		}else{
			str = str  + noiseVals[s] + " \t ";

		}
	}

return str;
}

function text_place(tf){
	
		
	for(var i = 0; i < meta.db.projects.length; i++){
			
		var dt1 = util_iso_to_datim(meta.db.projects[i].datetimeStart);
		var dt2 = util_iso_to_datim(meta.db.projects[i].datetimeEnd);

		var dt = dt1.getFullYear() + " "+dt1.getMonth() 
		+" - " + dt2.getFullYear() + " "+dt2.getMonth() ;
		text_add_and_format(tf,"<LF>id: "+ meta.db.projects[i].id+" ","id",i,0, "id");

		text_add_and_format(tf,"timespan: " + dt + "","h2",i,0, "id");

		text_add_and_format(tf,meta.db.projects[i].title+"","h1",i,0,"title");
				
		try{
			text_add_and_format(tf,meta.db.projects[i].workspace.title+"","h1",i,0,"title");
			}catch(e){}
		
		text_add_and_format(tf,meta.db.projects[i].text,"body",i,0,"text");
		for(var j = 0; j < meta.db.projects[i].posts.length;j++){

			text_add_and_format(tf,meta.db.projects[i].posts[j].titel,"h2",i,j,"post title");
			text_add_and_format(tf,meta.db.projects[i].posts[j].text + "\n","body",i,j,"post text");					
		}
	}
}


 

 

function text_addLegend(tf){
	text_add_and_format(tf,"\n\nlegend\n","h1",0,0,"legend");
	for(var i = 0; i < meta.db.projects.length; i++){
		
		text_add_and_format (tf, "id: " + meta.db.projects[i].id +" "+meta.db.projects[i].title+"\n", "id", i, 0, "legend");
//~		tf.paragraphs.lastItem().fillTint = 100;
	}
}

function text_takeOutTheTrash(doc){
var findGrepPref  = app.findGrepPreferences;
var chngGrepPref = app.changeGrepPreferences;
var findTextPref  = app.findTextPreferences;
var chngTextPref = app.changeTextPreferences;
	text_set_FindChange_opt();
	text_emptyFC();
	
	// this is housekeeping
var strings = new Array();
	strings[0] = "</span>";
	strings[1] = "<span>";
	strings[2] = "<ol>";
	strings[3] = "</ol>";
	strings[4] = "<li>";
	strings[5] = "</li>";
	strings[6] = "\t";
	strings[7] = "<cite>";
	strings[8] = "</cite>";
	strings[9] = "</ul>";
	strings[10] = "<ul>";
	strings[11] = "<..>";
	strings[12] = "<...>";
	strings[13] = "<.>";
	strings[14] = "</p>";
	strings[15] = "<p>";
	strings[16] = "<p >";
	strings[17] = "</p >";
	strings[18] = "style=“color: #000000;“";
	strings[19]  = "style=“text-decoration: underline;“";
	strings[20]  = "style=“text-decoration: underline;“";
	strings[21]  = "style=“text-align: left;“";
	strings[22]  = "style=“text-align: right;“";
	strings[23]  = "style=“text-align: center;“";
	strings[24]  = "</span >";
	strings[25]  = "<span >";
	strings[26]  = "style=“color: #";
	strings[27]  = "span ";
	strings[28]  = ";“";
	
	strings.push("<br />");
	strings.push("<h1>");
	strings.push("<h2>");
	strings.push("<h3>");
		strings.push("</h3>");

	strings.push("</h1>");
	strings.push("</h2>");
	strings.push("<hr />");
	strings.push("</em>");
	strings.push("<em>");
	strings.push("<strong>");
	strings.push("</strong>");


	for(var i = 0;i < strings.length;i++){
		text_set_FindChange_opt();
		findTextPref.findWhat = strings[i];
		chngTextPref.changeTo = "";
		doc.changeText();
		text_emptyFC();
	}
	text_emptyFC();
	
	// replace some html encoded characters
	
var replaceS = new Array();
	replaceS.push({"fw":";amp","to":"&"});
	replaceS.push({"fw":"amp;","to":"&"});
//~ var replaceT = new Array();
//~	 replaceT.push("&");
//~	 replaceT.push("&");

	
	for(var j = 0;j < replaceS.length;j++){
		text_set_FindChange_opt();
		findTextPref.findWhat = replaceS[j].fw;
		chngTextPref.changeTo = replaceS[j].to;
		doc.changeText();
		text_emptyFC();
	}
}


function text_grepReformatting(doc){
	
var fGPref  = app.findGrepPreferences;
var cGPref = app.changeGrepPreferences;


var greps_ = new Array();
	// use json objects to keep it tidy
	// fw is the find what
	// to is the change to
	greps_.push({   "fw":"  +"	  ,		"to":" "});
	greps_.push({   "fw":"\r "	  ,		"to":"\r"});
	greps_.push({   "fw":" \r"	  ,		"to":"\r"});
	greps_.push({   "fw":"\t\t+"	,	  "to":"\t"});
	greps_.push({   "fw":"\r\t"	 ,	   "to":"\r"});
	greps_.push({   "fw":"\t\r"	 ,	   "to":"\r"});
	greps_.push({   "fw":"\r\r+"	,	  "to":" ~7 "});
	greps_.push({   "fw":"\r"	   ,		 "to":" ~7 "});
	greps_.push({   "fw":"\n"	   ,		 "to":" ~7 "});
	greps_.push({   "fw":"~b"	   ,		 "to":" ~7 "});
	greps_.push({   "fw":"~7 ~7"	,	  "to":" ~7 "});
	greps_.push({   "fw":" ~7  ~7 " ,   "to":" ~7 "});
	greps_.push({   "fw":"<LF>"	 ,	   "to":"\r"});// this is my personal linefeed
	greps_.push({   "fw":"<a\ href\=\"(.*?)\">"	 ,	   "to":" $1 "});// find link
    greps_.push({   "fw":"alt\=\".*?\""	 ,	   "to":" "});// fand alternate
   
    greps_.push({   "fw":"<img src\=\"(.*?)\"\ {0,3}/>"	 ,	   "to":" $1 "});// find img as html

	greps_.push({   "fw":"</a>"	 ,	   "to":" "});// find end of href tag
	greps_.push({   "fw":"\&hellip;"	 ,	   "to":"&"});// find & in html
	greps_.push({   "fw":"\&quot;"	 ,	   "to":"\""});// find quotew in html
    greps_.push({   "fw":"~7\ \ {2,3}"	 ,	   "to":""});// also to many
    greps_.push({   "fw":"\ ~7\ \ ~7\ "	 ,	   "to":"\ ~7\ "});//to many paragraph signs
    greps_.push({   "fw":"\ \ "	 ,	   "to":"\ "});// double spaces


	text_emptyFC();
	// now loop thru the object to get all the greps
	for(var j = 0;j < greps_.length;j++){
		fGPref.findWhat = greps_[j].fw;
		cGPref.changeTo = greps_[j].to;
		doc.changeGrep();
		text_emptyFC();
	}
	text_emptyFC();
}



/**
 * this function takes out html trash 
 *
 */

function text_set_FindChange_opt(){
	
	text_emptyFC();
	//Set the find options.
	app.findChangeGrepOptions.includeFootnotes = true;
	app.findChangeGrepOptions.includeHiddenLayers = false;
	app.findChangeGrepOptions.includeLockedLayersForFind = false;
	app.findChangeGrepOptions.includeLockedStoriesForFind = true;
	app.findChangeGrepOptions.includeMasterPages = true;
	
}

function text_emptyFC(){
	//Clear the find/change grep preferences.
	app.findGrepPreferences = NothingEnum.nothing;
	app.changeGrepPreferences = NothingEnum.nothing;
	
	//Clear the find/change text preferences.
	app.findTextPreferences = NothingEnum.nothing;
	app.changeTextPreferences = NothingEnum.nothing;
}



function text_find_HTML_tags(doc) {
	text_set_FindChange_opt();
//~ var findGrepPref  = app.findGrepPreferences;
//~ var chngGrepPref = app.changeGrepPreferences;
//~ 	
var findTXTPref  = app.findTextPreferences;
var chngTXTPref = app.changeTextPreferences;
	
	text_emptyFC();
	
var easyTagToPS = new Array();
	easyTagToPS[0] = "h1";
	easyTagToPS[1] = "h2";
//~ 	easyTagToPS[2] = "h3";
//~ 	easyTagToPS[3] = "h4";
//~ 	easyTagToPS[4] = "h5";
//~ 	easyTagToPS[5] = "h6";


	for(var i = 0; i < easyTagToPS.length; i++){
	
		findGrepPref.findWhat = "<"+ easyTagToPS[i] + ">(.*?)</" + easyTagToPS[i] + ">";
		
		var res = doc.findText();
		res.appliedParagraphStyle = easyTagToPS[i];
		chngGrepPref.changeTo = "$1\r";
//~		 chngGrepPref.appliedParagraphStyle = easyTagToPS[i];
//~ 		chngGrepPref.appliedCharacterStyle = doc.characterStyles.item(0);
		doc.changeGrep();
		text_emptyFC();
	}
}



