﻿// inspect_meta.jsx

// Copyright (C) 2011 Fabian "fabiantheblind" Morón Zirfas
// http://www.the-moron.net
// http://fabiantheblind.info/
// info [at] the - moron . net

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/

#include "db.json"
#include "utility.jsx"
#include "db_utils.jsx"
#include "colors.jsx"
#include "document.jsx"
#include "styles.jsx"
#include "weblinks.jsx"




var meta = new Object();
	meta.db = data;// this comes from the included db.json
	meta.DEBUG = false; // this is for debugging
	// this is for quicker editing 
	// in the final render switch in the overlay and the image place
	meta.flsFolder = null;// the folder for the images
	meta.sortedFiles = null;
//~	 meta.Masterframe = null;
	db_sort_by_starttime();
	db_remove_firstelement();// removes old junk
	db_build_imageList();

// if you want to write your own scripts. copy all above into your new file
// than have a look in to the object meta with the function prop() below.
// you can now add and remove objects from meta. e.g.

	meta.prjList = [1173, 1362, 1754]; // the projects to highlite
	meta.highlite = [
	{"id":0, "name":"0","col":[255,255,255]},
	{"id":1173,"name":"1173","col":[153,51,255]},
	{"id":1362,"name":"1362","col":[102,153,255]},
	{"id":1754,"name":"1754","col":[51,204,204]}
	];
	
	meta.imgW = 25; // the image sizes
	meta.imgH = 25;
   
	meta.placeImages = true;   

	meta.pw = 3000; // this will hold the page width
	meta.ph = 841; // this will hold the page width
	// these are the margins
	meta.left = 42;
	meta.right = 42;
	meta.top = 50;
	meta.bottom = 75;
	meta.textColumnCount = 20;
    meta.cCount = 80;
    // calculate the gutter depending on how many images per column
    meta.gutter = ((meta.pw - (meta.left + meta.right)) - (meta.imgW*80)) / 79;
    meta.skipImages = false;
    meta.colorsonly = false;
    meta.addImageOverlay = true;

	// this will be filled with data from the db.json
	// sorted by startdate
    
    
// in meta.db.projects you find all the incom projects.

// if you want to use your own projects contact me
   

prop(meta);


// the function below is
// by Peter the Magnificant Kahrel
// http://www.kahrel.plus.com/indesign/scriptui.html

function prop (f) {
$.writeln (f.reflect.name);
var props = f.reflect.properties;
var array = [];
for (var i = 0; i < props.length; i++)
try {array.push (props[i].name + ": " + f[props[i].name])} catch (_){} array.sort ();
$.writeln (array.join ("\r"));
}