﻿// document.jsx
// Copyright (C) 2012 Fabian "fabiantheblind" Morón Zirfas
// http://www.the-moron.net
// http://fabiantheblind.info/
// info [at] the - moron . net

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/
function doc_build(doc, makeColumns,facingPages){
	doc.layers.item(0).name = "content";	
	doc.layers.add({name:"highlite"});
	
	// set some parameters
doc.viewPreferences.properties = {
	horizontalMeasurementUnits: MeasurementUnits.MILLIMETERS,
	verticalMeasurementUnits:MeasurementUnits.MILLIMETERS
	};
		doc.documentPreferences.properties = {
		pageWidth : meta.pw,
		pageHeight : meta.ph,
        documentBleedBottomOffset : 3,
        documentBleedTopOffset : 3,
        documentBleedInsideOrLeftOffset : 3,
        documentBleedOutsideOrRightOffset : 3
	};

doc.gridPreferences.properties = {
	 baselineStart : meta.top
	
	}
	doc.gridPreferences.baselineDivision = "15pt";
	
var msp1 = doc.masterSpreads.item(0).pages.item(0);// edit the masterspreads
	msp1.marginPreferences.properties = {
		right:meta.right,
		top:meta.top,
		left:meta.left,
		bottom:meta.bottom,
		 columnGutter:meta.gutter,
	};  

var msp2 = doc.masterSpreads.item(0).pages.item(1);//edit the other masterspred

	msp2.marginPreferences.properties = {
	  right:meta.right,
		top:meta.top,
		left:meta.left,
		bottom:meta.bottom,
		 columnGutter:meta.gutter,
	};  

if(makeColumns){
msp1.marginPreferences.columnCount = meta.textColumnCount;
msp2.marginPreferences.columnCount = meta.textColumnCount;
 
    }
if(facingPages){
    		doc.documentPreferences.facingPages = true;

    
    }else{
        
        
    		doc.documentPreferences.facingPages = false;
        }

	}// end make doc